com.ihr.xbrl.om.assertions

## Class XBRLAssertion

- java.lang.Object
- - com.ihr.xbrl.om.XMLFragment
  - - com.ihr.xbrl.om.exLinks.XLinkElement
    - - com.ihr.xbrl.om.exLinks.XBRLPointerOfARelationship
      - - com.ihr.xbrl.om.exLinks.XBRLResource
        - - com.ihr.xbrl.om.formula.XBRLFormulaResource
          - - com.ihr.xbrl.om.formula.XBRLVariableSetResource
            - - com.ihr.xbrl.om.assertions.XBRLAssertion

- All Implemented Interfaces:
    HasAdditionalEqualityForReassignation, AssertionEvaluationLocal, EvaluableAssertion, StaticAssertionCheck, XBRLRelationshipPoint, XBRLMessageContext, HasFormulaProcessor, HasUncoveredAspectValueResolver, XBRLVariablesHolder, XMLEvaluationContextProvider, Thinable, XBRLValidation, XBRLValueKey, XMLHasParent, java.lang.Cloneable, javax.xml.namespace.NamespaceContext
  Direct Known Subclasses:
    XBRLExistenceAssertion, XBRLValueAssertion

      public abstract class XBRLAssertion
      extends XBRLVariableSetResource
      implements EvaluableAssertion, XMLEvaluationContextProvider, AssertionEvaluationLocal, StaticAssertionCheck, XBRLMessageContext

  The Class XBRLAssertion.
  Author:
    Ignacio

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.ihr.xbrl.om.XBRLValidation

      `XBRLValidation.Direction`

  - ### Field Summary

    - ### Fields inherited from class com.ihr.xbrl.om.formula.XBRLVariableSetResource

      `aspectModel, implicitFiltering, log`

    - ### Fields inherited from class com.ihr.xbrl.om.exLinks.XBRLResource

      `nullResource`

    - ### Fields inherited from class com.ihr.xbrl.om.exLinks.XLinkElement

      `actuate, ACTUATE, ARC, arcrole, ARCROLE, ETITLE, EXTENDED, from, FROM, href, HREF, label, LABEL, LOCATOR, RESOURCE, role, ROLE, show, SHOW, SIMPLE, title, TITLE, to, TO, TYPE`

    - ### Fields inherited from class com.ihr.xbrl.om.XMLFragment

      `CONCEPT_LABEL, CONCEPT_QNAME, EASY_TO_READ, ELEMENT_LABEL, EMPTYRELATIONSHIPSITERATORINSTANCE, EMPTYXMLFRAGMENTITERATORINSTANCE, FACT_CONCEPT_DATATYPE, FACT_CONCEPT_LABEL, FACT_QNAME, HIDE_COMMON_ACCURACY, idQName, NO_POSITION, OrderComparator, OrderComparator2, PERIOD_TYPE, PERIOD_VALUE, SHORT_TEXT, SOURCE_DOCUMENT, XPATH, XPOINTER`

    - ### Fields inherited from interface com.ihr.xbrl.om.formula.XBRLVariablesHolder

      `MODEL_DIMENSIONAL, MODEL_NON_DIMENSIONAL`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `XBRLAssertion(XBRLFormulaProcessor proc, XBRLExtendedLink parent, net.sf.saxon.s9api.XdmNode resNode)` Creates a new assertion from a node in an extended link.
    `XBRLAssertion(XBRLFormulaProcessor proc, XBRLResource other)` Assertions are normally created by copying another existing resource.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `XBRLAssertionResult[]` | `evaluateAssertion(XBRLInstance doc)` Required for evaluating the assertion.
    `XMLFragment` | `getEvaluationContext()` Gets the evaluation context.
    `abstract java.lang.String` | `getExpression()` Returns the assertion XPath expression.
    `java.lang.String` | `getToolTipText()` Returns a small text with HTML code that can be represented in a tool tip with information about this XMLFragment.
    `void` | `resetEvaluationContext()` Reset evaluation context.
    `void` | `staticCheck()` Static check.

    - ### Methods inherited from class com.ihr.xbrl.om.formula.XBRLVariableSetResource

      `allDimensions, bindCycle, bindLastEvaluatedVariableValues, bindParameters, bindVariableValue, checkCyclicDependencies, compileFilters, compileFormulaExpression, declareVariables, getAspectModel, getBindableVariableNames, getFilters, getNumberOfVariables, getOptimizer, getUncoveredAspectsSet, getUncoveredAspectValue, getVariableResource, getVariableResourceUses, getVariableUse, getVariableValue, getVariableValue, getXFIImplicitFilterOptimizer, isCovered, isImplicitFilter`

    - ### Methods inherited from class com.ihr.xbrl.om.formula.XBRLFormulaResource

      `getProcessor`

    - ### Methods inherited from class com.ihr.xbrl.om.exLinks.XBRLResource

      `addChild, clear, equals, generateLocatorToNode, generateNode, getAttributes, getDTSBase, getFriendlyName, getFriendlyName, getParent, getResourceIdentifier, getRoleType, getType, getValidationReport, getValueKey, hashCode, invalidate, invalidate, isComplexType, isOnValidation, isSimpleType, setComplexType, setDTSBase, setId, setParent, setRole, setRoleType, setSimpleType, setValue, validate`

    - ### Methods inherited from class com.ihr.xbrl.om.exLinks.XLinkElement

      `getActuate, getArcrole, getFromTxt, getHRef, getLabel, getRole, getShow, getStaticLabel, getSType, getTitle, getToTxt, isRequiredAttribute, isValidAttribute, setActuate, setArcrole, setFrom, setHRef, setLabel, setShow, setSType, setTitle, setTo`

    - ### Methods inherited from class com.ihr.xbrl.om.XMLFragment

      `addAttribute, addFromRelationship, addNamespace, addNamespace, addToRelationship, addXMLChild, changeBase, checkBase, clone, clone, delAttribute, delAttribute, equalXdmValues, evaluateBoolean, evaluateList, evaluateNode, evaluateNumber, evaluateString, generateId, generateNodeNamespacesAndAttributes, generateNodeValue, generatePrefix, getAllAttributes, getAttribute, getAttributeBooleanValue, getAttributeQNameValue, getAttributes, getAttributeStringValue, getAttributeValue, getBase, getBase, getBaseURI, getBooleanValue, getChild, getContainer, getContainerDocumentURI, getDeclaredNamespaces, getDocument, getElements, getElementsHashCode, getFragment, getFromRelationships, getFromRelationships, getFromRelationships, getFromRelationships, getFromRelationships, getGenericLabelText, getId, getLang, getNamespaceURI, getNodeName, getNumberOfAttributes, getNumberOfElements, getNumberOfFromRelationships, getNumberOfToRelationships, getOrGenerateId, getPrefix, getPrefixes, getQNameValue, getRelationshipsBases, getRelationshipsChain, getRelationshipTypes, getStaticContext, getStaticNamespace, getStringValue, getToRelationships, getToRelationships, getToRelationships, getToRelationships, getToRelationships, getValue, getXPathExecutable, getXPathNamespaceContext, getXPathToNode, getXPathToRoot, getXPointerElementScheme, getXPointerElementScheme, getXPointerShorthandScheme, getXPointerToNode, isDead, isNamespaceDefined, isXdmDocumentAttached, objEquals, objHashCode, qNameToString, removeAttribute, removeChild, removeChild, removeFromRelationship, removeToRelationship, removeXMLChild, resetElements, resetHash, resolve_equal2, resolveHRef, resolveHRef, s_equal2, s_equal2, s_equal2, setAttributes, setBase, setDocument, setDocumentAndReload, setElements, setLang, setNamespaceContext, setNamespaces, setNode, setNodeName, setParent, setRegenerateNodeIfnotFound, setValue, setVariablesDefined, size, thin, toString, valueEquals, xEqual`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.ihr.xbrl.om.assertions.EvaluableAssertion

      `getErrorIdentification, getLabel, getResource`

    - ### Methods inherited from interface com.ihr.xbrl.om.assertions.AssertionEvaluationLocal

      `evaluateAssertionType`

    - ### Methods inherited from interface com.ihr.xbrl.om.assertions.StaticAssertionCheck

      `staticAssertionCheck`

    - ### Methods inherited from interface com.ihr.xbrl.om.formula.errors.XBRLMessageContext

      `collectAssertionVariablenames, getAssertionContextItem, getAssertionMessageVariables`

    - ### Methods inherited from interface com.ihr.xbrl.om.formula.HasFormulaProcessor

      `getProcessor`

    - ### Methods inherited from interface com.ihr.xbrl.om.exLinks.XBRLRelationshipPoint

      `addFromRelationship, addToRelationship, getFromRelationships, getToRelationships, removeFromRelationship, removeToRelationship`

- - ### Constructor Detail

    - #### XBRLAssertion

          public XBRLAssertion(XBRLFormulaProcessor proc,
                       XBRLExtendedLink parent,
                       net.sf.saxon.s9api.XdmNode resNode)
                        throws XFValidationException

      Creates a new assertion from a node in an extended link.
      Parameters:
        `proc` - the proc
        `parent` - the parent
        `resNode` - the res node
      Throws:
        `XFValidationException` - the XF validation exception

    - #### XBRLAssertion

          public XBRLAssertion(XBRLFormulaProcessor proc,
                       XBRLResource other)
                        throws XFValidationException

      Assertions are normally created by copying another existing resource.
      Parameters:
        `proc` - the proc
        `other` - the other
      Throws:
        `XFValidationException` - the XF validation exception

  - ### Method Detail

    - #### evaluateAssertion

          public XBRLAssertionResult[] evaluateAssertion(XBRLInstance doc)
                                                  throws XFValidationException

      Description copied from interface: `EvaluableAssertion`
      Required for evaluating the assertion.
      Specified by:
        `evaluateAssertion` in interface `EvaluableAssertion`
      Parameters:
        `doc` - the doc
      Returns:
        the XBRL assertion result[]
      Throws:
        `XFValidationException` - the XF validation exception

    - #### getEvaluationContext

          public XMLFragment getEvaluationContext()

      Description copied from interface: `XMLEvaluationContextProvider`
      Gets the evaluation context.
      Specified by:
        `getEvaluationContext` in interface `XMLEvaluationContextProvider`
      Returns:
        the evaluation context

    - #### resetEvaluationContext

          public void resetEvaluationContext()

      Reset evaluation context.

    - #### staticCheck

          public void staticCheck()
                           throws XFValidationException

      Static check.
      Throws:
        `XFValidationException` - the XF validation exception

    - #### getExpression

          public abstract java.lang.String getExpression()

      Returns the assertion XPath expression.
      Returns:
        String

    - #### getToolTipText

          public java.lang.String getToolTipText()

      Description copied from class: `XMLFragment`
      Returns a small text with HTML code that can be represented in a tool tip with information about this XMLFragment. This method shall be extended on specialized classes, the default implementation returns just the XML Fragment QName
      Overrides:
        `getToolTipText` in class `XMLFragment`
      Returns:
        the XMLFragment QName to string